<template lang="html">
  <div class="game-header">
    <div class="game-header-content-container">
      <div class="game-header-content">
        <div class="title-container">
          <h1 class="title">{{title}}</h1>
          <div v-if="!hasBrowserSupport" class="browser-support">
            {{ label.NO_SUPPORT }}
          </div>
          <div v-else-if="hasPrice()" class="price-container">
            <div class="price-icon">$</div>
            <div class="price-text">
              <span>{{ label.FROM }}</span> <span>{{ totalPrice }}</span>
            </div>
          </div>
          <div v-else class="free-container">{{ label.FREE }}</div>
        </div>
        <div class="user-header">
          <!--
          <span class="user-name-container">
            <nuxt-link :to="{ name: 'username', params: { username: publisher.username }}">
              <span>{{publisher.alias}}</span>
            </nuxt-link>
          </span>
          -->
          <!--
          <span class="metaData-container">
            <span class="metaData">{{metaData.amount}} {{metaData.unit}}</span>
          </span>
          -->
        </div>
        <div class="actions-container">
          <!--
          <div class="add-btn-container">
            <button class="add-btn"></button>
          </div>
          <div class="share-btn-container">
            <button class="share-btn"></button>
          </div>
          <div class="flag-btn-container">
            <button class="flag-btn"></button>
          </div>
          -->
          <div class="play-btn-container">
            <button v-if="!isAccessVerified || hasAccess"
              v-on:click="verifyGamePlayAccess()"
              class="play-btn">{{ label.PLAY_NOW }}</button>
            <button v-else
              v-on:click="verifyGamePlayAccess()"
              v-show="showPayBtn"
              class="play-btn"><span class="play-btn-price-text">{{ totalPrice }}</span> {{ label.BUY_PLAY_NOW }}</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex'
import priceUtil from '~/utils/priceUtil'

export default {
  name: 'ep-game-header',
  props: {
    gid: {
      type: String,
      default () {
        return '0123456789'
      }
    },
    title: {
      type: String,
      default () {
        return 'World of Warcraft'
      }
    },
    publisher: {
      type: Object,
      default () {
        return {
          uid: 'default_uid',
          username: 'Blizzard',
          alias: 'Blizzard Entertainment',
          icon: ''
        }
      }
    },
    price: {
      type: Object,
      default () {
        return {
          amount: 199
        }
      }
    },
    hasAccess: {
      type: Boolean,
      default () {
        return false
      }
    },
    isAccessVerified: {
      type: Boolean,
      default () {
        return false
      }
    },
    hasBrowserSupport: {
      type: Boolean,
      default () {
        return false
      }
    },
    metaData: {
      type: Object,
      default () {
        return {
          amount: '363,986,192',
          unit: 'plays'
        }
      }
    },
    showPayBtn: Boolean
  },
  data () {
    return {
      label: {
        PLAY_NOW: 'Play Now',
        BUY_PLAY_NOW: '- Buy and Play Now',
        BUY: 'BUY GAME',
        FROM: 'Play from ',
        FREE: 'FREE TO PLAY',
        NO_SUPPORT: '* Browser not supported'
      }
    }
  },
  computed: {
    ...mapState('app', [
      'dialogTypes'
    ]),
    ...mapGetters([
      'profile'
    ]),
    totalPrice () {
      return priceUtil.totalPrice(this.price.amount, this.price.unit)
    }
  },
  methods: {
    ...mapActions('app', [
      'selectDialog'
    ]),
    verifyGamePlayAccess () {
      this.$emit('verify-game-play-access')
    },
    hasPrice () {
      return this.price.amount > 0
    },
    showDialog (option) {
      this.selectDialog({
        dialog: this.dialogTypes[option]
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/theme';

.game-header {
  display: block;

  &-content-container {
    display: inline;
    list-style: none;
  }

  &-content {
    display: block;
    margin: 0;
    padding: 16px;
    border-top: none;
    border-right: none;
    border-left: none;
    background: #fff;
    //border: 1px solid #dcdcdc;
    overflow: auto;
    position: relative;
    border-radius: 2px;
    box-sizing: border-box;
  }

  h1, h2, h3 {
    color: $text-color;
    font-weight: normal;
    margin: 0;
  }
}

.title-container {
  position: relative;
  word-wrap: break-word;

  .title {
    font-size: 18px;
    margin-right: 86px;
  }
}

.browser-support, .price-container, .free-container {
  position: absolute;
  top: 0;
  right: 0;
  border: 0;
  line-height: 16px;
  height: 16px;
  font-size: 12px;
  text-decoration: none;
  color: $dark-gray;
}

.price-icon {
  margin: 0 2px 0 0;
  display: inline-block;
  background-color: $blue;
  padding: 0 4px;
  border-radius: 2px;
  color: #fff;
}

.price-text {
  display: inline-block;
}

.user-header {
  display: block;
  line-height: 18px;
  margin: 6px 0;

  a {
    color: $text-color;
    text-decoration: none;
  }
}

.metaData-container {
  font-size: 12px;
  color: $dark-gray;
  overflow: hidden;
  white-space: nowrap;
  word-wrap: normal;
  text-overflow: ellipsis;

  &::before {
    content: "\0000b7";
    margin-right: 5px;
  }
}

.actions-container {
  display: block;
}

.add-btn-container, .share-btn-container, .flag-btn-container {
  display: inline-block;
  margin-right: 20px;
}

.add-btn, .share-btn, .flag-btn {
  width: 24px;
  height: 24px;
  padding: 0;
  margin: 0;
  border: none;
}

.add-btn {
  background-position: -4px -0px !important;
  background: no-repeat url('/static/image/icon/add-icon.png');
}

.share-btn {
  background: no-repeat url('/static/image/icon/share-icon.png');
}

.flag-btn {
  background: no-repeat url('/static/image/icon/flag-icon.png');
}

.play-btn-container {
  float: right;
}

.play-btn {
  font-size: 20px;
  font-weight: bold;
  border: none;
  padding: 12px 20px;
  background-color: $secondary-color;
  color: #fff;
  border-radius: 2px;

  &-price-text {
    font-size: 18px;
  }
}
</style>
